package com.qmth.sop.business.bean.bean;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import com.qmth.sop.business.bean.result.FlowTaskResult;
import com.qmth.sop.common.enums.FlowStatusEnum;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;
import java.util.Objects;

/**
 * @Description: 流程表单属性bean
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2023/7/24
 */
@JsonInclude(JsonInclude.Include.NON_NULL)
public class FormPropertyBean implements Serializable {

    @ApiModelProperty(value = "流程id")
    @JsonSerialize(using = ToStringSerializer.class)
    Long flowId;

    @ApiModelProperty(value = "流程状态")
    FlowStatusEnum status;

    @ApiModelProperty(value = "流程状态")
    String statusStr;

    @ApiModelProperty(value = "sop单号")
    String sopNo;

    @ApiModelProperty(value = "流程任务id")
    @JsonSerialize(using = ToStringSerializer.class)
    Long taskId;

    @ApiModelProperty(value = "用户id")
    @JsonSerialize(using = ToStringSerializer.class)
    Long userId;

    @ApiModelProperty(value = "动态表单")
    FlowTaskResult setupMap;

    public FormPropertyBean() {

    }

    public FormPropertyBean(Long flowId, Long taskId, FlowTaskResult setupMap) {
        this.flowId = flowId;
        this.taskId = taskId;
        this.setupMap = setupMap;
    }

    public FormPropertyBean(Long flowId, Long taskId, Long userId, FlowTaskResult setupMap, FlowStatusEnum status, String sopNo) {
        this.flowId = flowId;
        this.taskId = taskId;
        this.userId = userId;
        this.setupMap = setupMap;
        this.status = status;
        this.sopNo = sopNo;
    }

    public String getStatusStr() {
        if (Objects.nonNull(status)) {
            return this.status.getTitle();
        } else {
            return statusStr;
        }
    }

    public void setStatusStr(String statusStr) {
        this.statusStr = statusStr;
    }

    public FlowStatusEnum getStatus() {
        return status;
    }

    public void setStatus(FlowStatusEnum status) {
        this.status = status;
    }

    public String getSopNo() {
        return sopNo;
    }

    public void setSopNo(String sopNo) {
        this.sopNo = sopNo;
    }

    public Long getFlowId() {
        return flowId;
    }

    public void setFlowId(Long flowId) {
        this.flowId = flowId;
    }

    public Long getTaskId() {
        return taskId;
    }

    public void setTaskId(Long taskId) {
        this.taskId = taskId;
    }

    public Long getUserId() {
        return userId;
    }

    public void setUserId(Long userId) {
        this.userId = userId;
    }

    public FlowTaskResult getSetupMap() {
        return setupMap;
    }

    public void setSetupMap(FlowTaskResult setupMap) {
        this.setupMap = setupMap;
    }
}
